
/*
 *  cube.c
 *  This program demonstrates a single modeling transformation,
 *  glScalef() and a single viewing transformation, gluLookAt().
 *  A wireframe cube is rendered.
 */
#include <OpenGL/OpenGL.h>
#include <GLUT/glut.h>

#include <stdlib.h>

void init(void) 
{
	glClearColor (0.0, 0.0, 0.0, 0.0);
	glShadeModel (GL_FLAT);
}

void display1(void)
{
	static int framecount = 0;
	
	glClear (GL_COLOR_BUFFER_BIT);
	glColor3f (1.0, 1.0, 1.0);
	glLoadIdentity ();             /* clear the matrix */
	/* viewing transformation  */
	float x_pos = - ((framecount++ % 60) - 30.0) / 8.0;
	gluLookAt (x_pos, 0.0, 5.0, x_pos, 0.0, 0.0, 0.0, 1.0, 0.0);
	glScalef (1.0, 2.0, 1.0);      /* modeling transformation */ 
	//glutWireCube (1.0);

	
	glColor3f(1,1,1);
	glBegin(GL_POLYGON);
	glVertex2f(-0.5,3);
	glVertex2f(-0.5,-3);
	glVertex2f(0.5,-3);
	glVertex2f(0.5,3);
	glEnd();
	
	glFinish ();
}

void reshape1 (int w, int h)
{
	glViewport (0, 0, (GLsizei) w, (GLsizei) h); 
	glMatrixMode (GL_PROJECTION);
	glLoadIdentity ();
	glFrustum (-1.0, 1.0, -1.0, 1.0, 1.5, 20.0);
	glMatrixMode (GL_MODELVIEW);
}

void glutIdle1(void)
{	
	glutPostRedisplay ();
}

void keyboard(unsigned char key, int x, int y)
{
	switch (key) {
		case 27:
			exit(0);
			break;
	}
}

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB);	
	glutInitWindowSize (500, 500); 
	glutInitWindowPosition (100, 100);
	glutCreateWindow (argv[0]);
	init ();
	glutDisplayFunc(display1); 
	glutReshapeFunc(reshape1);
	glutIdleFunc(glutIdle1);
	
	glutKeyboardFunc(keyboard);

	GLint sync = 1;
	CGLSetParameter(CGLGetCurrentContext(), kCGLCPSwapInterval, &sync);
	CGLEnable( CGLGetCurrentContext(), kCGLCEMPEngine);
	
	glutMainLoop();
	return 0;
}
